
/*
 * Annex II requires certification service providers to:
 * 
 *     Demonstrate the reliability necessary for providing certification services
 * 
 *     Ensure the operation of a prompt and secure directory and a secure and immediate revocation service
 * 
 *     Ensure that the date and time when a certificate is issued or revoked can be determined precisely
 * 
 *     Verify, by appropriate means in accordance with national law, the identity and, if applicable, any specific attributes of the person to which a qualified certificate is issued
 * 
 *     Employ personnel who possess the expert knowledge, experience, and qualifications necessary for the services provided, in particular competence at managerial level, expertise in electronic signature technology and familiarity with proper security procedures. They must also apply administrative and management procedures which are adequate and correspond to recognized standards.
 * 
 *     Use trustworthy systems and products which are protected against modification and ensure the technical and cryptographic security of the process supported by them
 * 
 *     Take measures against forgery of certificates, and, in cases where the certification service provider generates signature creation data, guarantee confidentiality during the process of generating such data
 * 
 *     Maintain sufficient financial resources to operate in conformity with the requirements laid down in the Directive, in particular to bear the risk of liability for damages, for example, by obtaining appropriate insurance
 * 
 *     Record all relevant information concerning a qualified certificate for an appropriate period of time, in particular for the purpose of providing evidence of certification for the purposes of legal proceedings. Such recording may be done electronically.
 * 
 *     Not store or copy signature creation data of the person to whom the certification service provider provided key management services
 * 
 *     Before entering into a contractual relationship with a person seeking a certificate to support their electronic signature, inform that person by a durable means of communication of the precise terms and conditions regarding the use of the certificate, including any limitations on its use, the existence of a voluntary accreditation scheme and procedures for complaints and dispute settlement. Such information, which may be transmitted electronically, must be in writing and in readily understandable language. Relevant parts of this information must also be made available on request to third parties relying on the certificate.
 * 
 *     Use trustworthy systems to store certificates in a verifiable form so that:
 * 
 *         Only authorized persons can make entries and changes
 * 
 *         Information can be checked for authenticity
 * 
 *         Certificates are publicly available for retrieval in only those cases for which the certificate holder's consent has been obtained

 *       Any technical changes compromising these security requirements are apparent to the operator
 */

