
/*
 * @copyright
 *
 *  Copyright 2015 Neo Natura
 *
 *  This file is part of the Share Library.
 *  (https://github.com/neonatura/share)
 *        
 *  The Share Library is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version. 
 *
 *  The Share Library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with The Share Library.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  @endcopyright
 */  

#ifndef __CARD__CARD_CSC_H__
#define __CARD__CARD_CSC_H__

/**
 * The CSC for each card (form 1 and 2) is generated by the card issuer when the card is issued. It is calculated by encrypting the bank card number, expiration date and service code with encryption keys known only to the card issuer, and decimalising the result.
 * @ingroup shared
 * @defgroup shared_dev
 * @{
 */


int card_csc_ver(shcard_t *card, int csc);

int card_csc_gen(shcard_t *card);



/**
 * @}
 */

#endif /* ndef __CARD__CARD_CSC_H__ */

